  .386                   ; set processor type, another option is .686
  .model flat, stdcall   ; memory model & calling convention
  option casemap :none   ; case sensitive

  ; ----------------------------------------------
  ; Include any needed INCLUDE and LIBRARY files
  ; and procedure prototypes.
  ; ----------------------------------------------
  include \masm32\include\windows.inc
  include \masm32\include\user32.inc
  include \masm32\include\kernel32.inc

  includelib \masm32\lib\user32.lib
  includelib \masm32\lib\kernel32.lib

Main PROTO

  ; ---------------------------------------------------
  ; Include any needed global constants and variables
  ; both initialized and uninitialized
  ; ---------------------------------------------------
.const
    con_init equ 255
.data
  _eax     dd 0
  _ecx     dd 0
  _edx     dd 0
  _ebx     dd 0
  _esp     dd 0
  _ebp     dd 0
  _esi     dd 0
  _edi     dd 0
  _flg     dd 0
  _cf      dd 0
  _pf      dd 0
  _af      dd 0
  _zf      dd 0
  _sf      dd 0
  _if      dd 0
  _df      dd 0
  _of      dd 0

  szCap    db "Display registers and flags",0
  szRegDec db "%010lu  EAX accumulator",13,10
           db "%010lu  ECX counter",13,10
           db "%010lu  EDX data",13,10
           db "%010lu  EBX base address",13,10
           db "%010lu  ESP stack pointer",13,10
           db "%010lu  EBP base pointer",13,10
           db "%010lu  ESI source index",13,10
           db "%010lu  EDI destination index",13,10
           db "%u  CF Carry Flag",13,10
           db "%u  PF Parity Flag",13,10
           db "%u  AF Auxilary Flag",13,10
           db "%u  ZF Zero Flag",13,10
           db "%u  SF Sign Flag",13,10
           db "%u  IF Interrupt Flag",13,10
           db "%u  DF Direction Flag",13,10
           db "%u  OF Overflow Flag",13,10,0

  szRegHex db "%08Xh  EAX accumulator",13,10
           db "%08Xh  ECX counter",13,10
           db "%08Xh  EDX data",13,10
           db "%08Xh  EBX base address",13,10
           db "%08Xh  ESP stack pointer",13,10
           db "%08Xh  EBP base pointer",13,10
           db "%08Xh  ESI source index",13,10
           db "%08Xh  EDI destination index",13,10
           db "%u  CF Carry Flag",13,10
           db "%u  PF Parity Flag",13,10
           db "%u  AF Auxilary Flag",13,10
           db "%u  ZF Zero Flag",13,10
           db "%u  SF Sign Flag",13,10
           db "%u  IF Interrupt Flag",13,10
           db "%u  DF Direction Flag",13,10
           db "%u  OF Overflow Flag",13,10,0
           
  szBufHex db 256 dup (0)
  szBufDec db 256 dup (0)

.data?
    var_unin dd ?

          
.code
start:

  invoke Main
  mov eax, _flg
  mov _cf, eax
  and _cf, 1
  mov _pf, eax
  shr _pf, 2
  and _pf, 1
  mov _af, eax
  shr _af, 4
  and _af, 1
  mov _zf, eax
  shr _zf, 6
  and _zf, 1
  mov _sf, eax
  shr _sf, 7
  and _sf, 1
  mov _if, eax
  shr _if, 9
  and _if, 1
  mov _df, eax
  shr _df, 10
  and _df, 1
  mov _of, eax
  shr _of, 11
  and _of, 1

  invoke wsprintf, ADDR szBufDec, ADDR szRegDec, _eax, _ecx, _edx, _ebx, _esp, _ebp, _esi, _edi,
                   _cf, _pf, _af, _zf, _sf, _if, _df, _of
  invoke MessageBox, 0, ADDR szBufDec, Addr szCap, MB_OK

  invoke wsprintf, ADDR szBufHex, ADDR szRegHex, _eax, _ecx, _edx, _ebx, _esp, _ebp, _esi, _edi,
                   _cf, _pf, _af, _zf, _sf, _if, _df, _of
  invoke MessageBox, 0, ADDR szBufHex, Addr szCap, MB_OK

  invoke ExitProcess,0


Main PROC
  mov  eax,10000h      ; EAX = 10000h
  add  eax,40000h      ; EAX = 50000h
  sub  eax,20000h      ; EAX = 30000h
  mov _eax, eax
  mov _ebx, ebx
  mov _ecx, ecx
  mov _edx, edx
  mov _esp, esp
  mov _ebp, ebp
  mov _esi, esi
  mov _edi, edi
  pushfd
  pop _flg
  ret
Main ENDP

end start